<script module>
import { nextTick, onMounted, ref } from 'vue'
import Map from './Map.vue';
import distance from '@turf/distance';
import center from '@turf/center';
import {useToast} from 'vue-toastification';

import config from "../../config.json";

let apiBaseURL = config.baseApiUrl+"/items/_geosearch";

export default {
    name:"Home",
    props:[],
    components:{
        Map
    },
    setup(){
      const mapInstance = ref(null);
      const markers = ref([]);
      const mapcenter = ref(null);
      const bounds = ref(null);
      const geojson = ref(null);
      const toast = useToast();

      const onMapReady = ()=>{
        searchItemsByRadius();
      }

      const searchItemsByRadius = async ()=>{
        console.log(bounds.value)
        let lat = mapcenter.value.lng;
        let lng = mapcenter.value.lat;
        // GET VIEW BOUNDS AS RECTANGULAR POLYGON:
        let radius = distance(
          [bounds.value._southWest.lat,
          bounds.value._southWest.lng],
          [lng,lat],{units:"meters"}
        )

        //////////////////////////////////////////////////////
        // GET ITEMS by search inside the center of that view:
        let newmarkers = []
        let items = await fetchJSON(apiBaseURL+`?latitude=${lat}&longitude=${lng}&radius=${parseInt(radius)}`);
        console.log(items.length,"items found");

        items.map((item)=>{
          let lpolygon = JSON.parse(item['location.geoJSON']);
          let lpoint = center(lpolygon);
          
          let newMarker = {
            pos:[lpoint.geometry.coordinates[1],lpoint.geometry.coordinates[0]],
            popup:`
              <h1 class='has-text-weight-bold'>${item.name}</h1>
              <p>
                ${item.description}
              </p>
            `
          }
          newmarkers.push(newMarker)
        })
        markers.value = newmarkers
      }

      const handleCenterMoved = (e)=>{
        mapcenter.value = e;
      }

      const handleSearchButtonClicked = ()=>{
        searchItemsByRadius(mapcenter.value.lat,mapcenter.value.lng,50000)
      }

      const handleBoundsChanged = (e)=>{
        bounds.value = e;
      }

      async function fetchJSON(url){
        const response = await fetch(url);
        let parsed;
        try{
          parsed = await response.json();
          if (parsed.error){toast.error(parsed.reason)}
        }catch(e){
          parsed = []
        }
        
        return parsed;
      }

      return {
        markers,
        mapcenter,
        handleCenterMoved,
        handleSearchButtonClicked,
        handleBoundsChanged,
        bounds,
        mapInstance,
        geojson,
        onMapReady,
        }
    },
}


</script>

<template>
  <h1>DINGSDA2MEX OPEN MAP</h1>

   <button v-if="bounds" class="button has-background-pink-1 has-text-light m-2" @click="handleSearchButtonClicked">SEARCH THIS AREA</button>
  <Map :ref="mapInstance" class="is-full-width is-full-height" :zoom="11" 
    :markers="markers" :area="geojson" :center="mapcenter" @centerMoved="handleCenterMoved" @boundsChanged="handleBoundsChanged"
    @mapReady="onMapReady"
  />
</template>
